\documentclass[12pt,letterpaper]{csdissertation}
\usepackage{graphicx}
\usepackage{url}
\usepackage{cite}
\usepackage{times}
\usepackage{url}
\usepackage{caption} 
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{textcomp}
\usepackage{gensymb}
\usepackage{float}
\usepackage{caption} 
\usepackage{subcaption}
\usepackage{array}
\usepackage{centernot}
\usepackage{amsmath}
% just a few additional packages you may find useful
%\usepackage{amssymb}
%\usepackage{amsmath}
%\usepackage{lscape}
%\usepackage{longtable}

% dimensions fix by Naser Madi nmadi@kent.edu
\usepackage[top=2in, bottom=1.5in, left=1in, right=1in]{geometry}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Material required by the dissertation document class
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\title{A Network-centric TCP for Interactive Video Delivery Networks (VDN)}
\author{MD Iftakharul Islam}
\degrees{Department of Computer Science, Kent State University\\ 
         mislam4@kent.edu}
\submitdate{September 2017}
\advisor{Dr. Javed I Khan}
\membera{Dr. Hassan Peyravi}
\memberb{Dr. Jong-Hoon Kim}
\memberc{Dr. Murali Shanker}
\memberd{Dr. }
\chair{Dr. Javed I Khan}
\dean{Dr. James L. Black}
\begin{document}
\frontmatter

%\prefacesection{Acknowledgements}
%   Your acknowledgements here

%\dedication{Your dedication here.}

\startthesis


\begin{abstract}
	%\boldmath
	Interactive video streaming requires very low latency and high throughput. Traditional latency based congestion control algorithm performs poorly in fairness. This results in very poor video quality to adaptive video streaming. Software defined networks (SDN) enables us to solve the problem by designing a network controller in the routers. This research presents a SDN-centric TCP where sending rate of the network is calculated from the network rather than the host. Routers along the path uses a \textit{proportional integral (PI)}  controller to calculate the sending rate in order to reduce the queuing delay. The routers also divide the available throughput fairly among the flows. The network based controller is found more effective than the sender/receiver based controller in reducing latency and providing fairness. NC-TCP has been designed for interactive video delivery network (VDN) where the interactive video flows compete among themselves. Such differentiated service obviates the need for \textit{TCP-friendliness}. NC-TCP uses a rate-based congestion control rather than traditional window-based mechanism. It uses \textit{TCP-pacing} for regulating the sending rate. We have implemented NC-TCP in Linux kernel. We have developed a TCP-based adaptive video streaming application based on GStreamer. We have evaluated NC-TCP in Mininet. We have compared the performance of NC-TCP to that of TCP Inigo and XCP. Our experimental results show that both NC-TCP and XCP outperforms delay-based congestion control, TCP Inigo in interactive VDN. NC-TCP also results in lower queuing delay compared XCP in interactive VDN.
	
\end{abstract}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\chapter{Introduction}\label{chpt:one}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Interactive video streaming over the Internet are expected to behave in a TCP-friendly manner. For example, Skype uses a TCP-friendly congestion control algorithm for video conferencing \cite{zhang2012profiling}. However competing with TCP flows adversely affect interactive video streaming. Loss-based congestion control of TCP fills up the router buffer (\textit{bufferbloat problem}) which increases delay. Again interactive video streaming also traditionally employs delay based congestion control algorithm which loses throughput to loss-based congestion control algorithm \cite{grieco2004performance}. Recent advances in network virtualization and differentiated service enable us to isolate interactive video traffic from other best effort services \cite{anderson2005overcoming, matta2000differentiated}. This obviates the need for TCP-friendliness and enables us to design congestion control algorithm where interactive video streaming competes among themselves.

Congestion control for real-time communication aims to minimize the delay. The first proposed delay based congestion control algorithm used  Round Trip Time (RTT) to infer congestion. In this case, a sender uses RTT characteristics to infer a delay threshold. The algorithms use these approach include TCP Vegas \cite{brakmo1995tcp} and TCP FAST \cite{wei2006fast}. It has been shown that RTT based congestion control results in lower link utilization in the presence of reverse traffic, which inflates queues in the backward path\cite{grieco2004performance}. To solve this problem, LEDBAT \cite{rossi2010ledbat} employs one-way delay to rule out the sensitivity to the reverse path congestion. These approach however suffers \textit{latecomer effect} : when two flows
share the same bottleneck, the second flow may starve the first one \cite{carofiglio2010quest}. Recently RTT gradient (change of RTT over time) has been employed to overcome the latecomer effect. Examples of such congestion control are TCP CDG \cite{hayes2011revisiting} and TCP Igino \cite{shewmaker2016tcp}. TCP CDG regulates the sending rate based on RTT gradient whereas TCP Igino regulates the sending rate based on one-way delay gradient. Google Hangout also uses one-way delay gradient based congestion control algorithm over RTP/RTCP \cite{lundin2012google}. 

Although delay-gradient based congestion control algorithms have been widely used for interactive video streaming, it has shown that they suffer from fairness issue \cite{de2013experimental, carlucci2016congestion}. It is important to mention that if flows cannot share throughput fairly, it results in poor video quality for the flows. Recent advances in software defined networks (SDN) however has a potential to solve this problem. Programmable switches \cite{bosshart2013forwarding, flexpipe, xplaint} and NICs \cite{nfp, han2015softnic} can provide us with explicit feedback from network. XCP\cite{katabi2002internet} is the first attempt in direction where explicit rate is assigned by the router based on persistent queuing delay and spare capacity of the bottleneck link. It has shown that XCP can be implemented on a router at line-rate \cite{sharma17evaluating}. But XCP makes no assumption about the traffic characteristic. In this research however we designed a network-centric TCP (NC-TCP) for interactive VDN where interactive video streaming competes among themselves. We have utilized the traffic characteristics to optimize throughput allocation. Here routers along the path calculate a sending rate based on PI controller in order to minimize the latency. Routers also divide the throughput fairly among the flows. Our experimental results show that such network centric approach results in small and smooth latency and better fairness in an interactive VDN.  

NC-TCP is designed as a rate-based congestion mechanism as opposed to XCP. It uses \textit{TCP-pacing} to regulate the sending rate. That is why, it does not send bursty traffic and it does not send more data than the network is able to deliver. NC-TCP also uses instantaneous queue backlog to calculate the feedback rate whereas XCP calculates the feedback rate based on the standing queue: minimum queue length over a control interval. This is why NC-TCP reacts to congestion quicker than XCP. Our experimental results show that NC-TCP performs better in containing small queue size compared to XCP in an interactive VDN. Our experimental results also shows that both NC-TCP and XCP preforms significantly better than delay-based congestion control, TCP Inigo in an interactive VDN.

Networked-centric congestion control has major advantage over traditional sender/receiver centric congestion control. Here the network controller has information about the competing flows and play an active role in regulating the flow rate. This is why the stability of the control system is easier to maintain compared to host centric approach where the controller of the system is distributed across the hosts. The centralized control system also facilitates to allocate the throughput fairly among the flows. Finally traditional host-based congestion control mechanism depends on implicit feedback such as delay-gradient and packet-loss to infer congestion. Contrary to that, NC-TCP uses actual network information to avoid the congestion.


The main contributions of this research are as following:
\begin{itemize}
	\item We have described the importance of TCP for interactive video video network (VDN). We have developed a network-centric TCP where rate is allocated by the routers along the path. We have shown that NC-TCP is stable and fair.
	\item Today most of the interactive video streaming applications such as Google Hangout and Cisco telepresence application use delay based congestion control \cite{lundin2012google, zhu2013nada}. However our studies have shown that delay based congestion control algorithm perform very poorly compared to explicit rate control algorithm. We have shown that both NC-TCP and XCP outperform TCP Inigo which is a one-way delay variant based congestion control algorithm similar to the one used in Google Hangout \cite{lundin2012google}. 
\end{itemize}

\chapter{Why TCP?}\label{chpt:tcp}
Interactive video streaming traditionally uses application layer rate control algorithm over UDP \cite{lundin2012google}. But this approach has some disadvantages. It forces the application developers to reimplement the common functionality. Different implementations of the congestion control algorithms interact poorly with each other, and the stability of the network is compromised. UDP is also not NAT and firewall friendly which are highly desirable attributes in today's Internet. TCP solves those problems,  however it has some disadvantages in the context of interactive video streaming. The ordered delivery of TCP delays some segment delivery if a prior segment is missing (\textit{head-of-line blocking } problem). Retransmission is also not often desirable in interactive video streaming. However it has shown that this problem can be avoided by modifying TCP implementation. Recently TCP Hollywood \cite{mcquistin2016tcp} has been designed as an unordered and time-line oriented TCP. It avoids the \textit{head-of-line blocking } problem by supporting unordered delivery. It also attaches a time-line to data. The data would be ignored after the time-line has been expired. This is how it avoids retransmission. Packet-loss can be further avoided by caching packets on the router. As NICs (network interface controllers) evolved from kbps to Gbps and memory chips from KB to GB, packet loss has become less of an issue.

\chapter{NC-TCP Algorithm}\label{chpt:nctcp}
NC-TCP is implemented as a new TCP option. The option consists of two fields: \textit{expected throughput} and \textit{feedback throughput}. Figure \ref{im-option} show the NC option along the the option type and option length. TCP Option is the intended mechanism by which TCP can be extended. An empirical experiment has shown that it is possible to extend TCP by implementing a new option even though these packets go through plethora of middle-boxes \cite{honda2011still} . The workflow of NC-TCP is shown in Figure \ref{workflow}. A sender specifies the required throughput in SYN and DATA packets. The feedback throughput would be set by the routers. The routers allocate a feedback throughput based on the link bandwidth, number of flows and queue occupancy. Receivers copy the feedback throughput to the acknowledgements packets. In this way, the feedback throughput would be returned to the sender. This is how the routers send an explicit feedback throughput to the senders. The feedback throughput would be used as a sending rate in the sender. Traditional TCP uses window based congestion control. Window-based based congestion control produces bursty traffic. Video streaming traditionally uses rate-based congestion control \cite{lundin2012google}. NC-TCP has been designed as a rate-based congestion control. It uses \textit{TCP-pacing} \cite{aggarwal2000understanding} to regulate the sending rate.

A video streaming flow may have more than one bottleneck links along the path. All the bottleneck routers need to run the network controller in order to allocate a throughput to the flow. A bottleneck router would assign the feedback rate to the packets if the rate is smaller than the feedback calculated by a previous router. In this way, a more congested downstream router can further reduce this feedback by overwriting it. This ensures that the going rate of a sender is adjusted to the most congested link on the path.



\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{fig/workflow}
	\caption{Work flow of NC-TCP}\label{workflow}
\end{figure}

\begin{figure}[!t]
	\centering
	\includegraphics[width=3cm]{fig/im-option}
	\caption{NC option}\label{im-option}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\chapter{Congestion Control}\label{chpt:cc}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
This section uses a \textit{Proportional Integral (PI)} controller in the router to calculate the aggregate feedback throughput based on the queue size. The routers also have a \textit{fairness} controller that divides the aggregate feedback throughput among the flows fairly. PI Enhanced (PIE) \cite{pan2013pie} controller has been  used in the Active Queue Management (AQM) techniques in the past. PIE uses Explicit Congestion Notification (ECN) to give a hint about the queuing delay. In contrast to that, NC-TCP uses the feedback throughput as a congestion signal. The feedback throughput from the router will be used as the sending rate of  the sender. We divide the feedback control system into two parts: Delay Controller and Fairness Controller.

\section{Delay Controller}\label{sect:cc_one}

The delay controller is designed based on PI controller. It calculates the aggregate feedback throughput based queue length and link capacity. In PI controller, the aggregate feedback throughput can described by the following equation:

\begin{equation}\label{eq1} \sum r_i(t) = \alpha[c(t) - q(t)]\end{equation}

where the $\sum r_i(t)$ is the aggregate feedback throughput, $c(t)$ is the bottleneck link capacity, $q(t)$ is the queue length in bytes and $\alpha$ is the coefficient. We need to determine the value of $\alpha$ for which the system stabilizes. Later we have shown that the system stabilizes for when $\alpha > 0$. The value of $\alpha$ is used to regulate the queuing delay and throughput. There is a trade-off between throughput and queuing delay. Later we have shown that $\alpha=1$ makes the queuing delay approaches to zero at the same time maximizing the feedback throughput.

\section{Fairness Controller}\label{sect:cc_two}

The objective of the fairness controller is to divide the capacity fairly among the flows. Here it uses min-max fairness to divide the available capacity among the flows equally. We can rewrite the equation (\ref{eq1}) as $r_i(t) = \frac{\alpha[c(t) - q(t)]}{N(t)}$ where $r_i(t)$ is the feedback throughput for flow $i$.

\section{Stability Analysis}\label{sect:cc_three}

This section shows that NC-TCP always converges to an equilibrium point. The feedback rate set by the router is sent back to the sender via acknowledgment. This is why there is a feedback delay in NC-TCP. Let us assume that the feedback delay is $t_f$. As the feedback rate becomes the sending rate after $t_f$,the sending rate at time $t$ can be written as
\begin{equation}\label{eq5}x_i(t) = \frac{\alpha [C - q(t - t_f)]}{N}\end{equation} Without loss of generality similar to all previous works \cite{katabi2002internet, dukkipati2007rate}, our analysis assumes that all flows have a common, finite, and positive round-trip delay and the link capacity and the number of flows  are constant for a session. The queuing-delay gradient can be represented as \begin{equation}\label{eq3}
\dot{q(t)} = \sum x_i(t) - C
\end{equation}
As flows adapt their sending rate $x_i(t)$ at the same rate, $\sum x_i(t) = N x_i(t)$ for all $i$. From equation (\ref{eq5}) and (\ref{eq3}) we get,  
\begin{equation}\label{eq4}
\dot{q(t)} = N x_i(t) - C \implies \dot{q(t)} = -\alpha q(t - t_f) + C(\alpha-1)
\end{equation}

This is an autonomous differential equation which describes the autonomous system. According to the stability theorem of autonomous differential equation, the system is stable if $\ddot{q(t^*)} < 0$ where $q(t^*)$ represents the queuing delay at the equilibrium point. This is why the system is stable if $\alpha > 0$. If the system is perturbed by burst of flows, the $q(t)$ increases. In that case, the queue will be drained at $-\alpha q(t - t_f) + C(\alpha-1)$ rate and eventually reaches the equilibrium point. 

At the equilibrium point, $\dot{q(t) = 0}$. Thus from the equation (\ref{eq4}), we get \begin{equation}\label{eq6}
q(t - t_f) = \frac{C(\alpha-1)}{\alpha}
\end{equation}
$\frac{C(\alpha-1)}{\alpha}$ is the queuing delay at the equilibrium point. The value of $\alpha$ controls the queuing delay and feedback throughput. Here we want the queuing delay to be be zero while maximizing the throughput. That is why we set $\alpha = 1$.


\chapter{Encoder Rate Control}\label{chpt:encoderratecontrol}

One of the main challenges of interactive video streaming is that the encoding rate of video cannot be changed quickly in order to avoid congestion. The video encoder reacts to encoding rate changes over discrete intervals which is usually more than 500 milliseconds. The actual encoder output rate also fluctuates randomly around the input target rate. The actual output rate of a video depends on the content of the video. This section shows how to set the target encoding rate based on the feedback rate.

The encoding rate in an adaptive video streaming is set based on the throughput of the network. Contrary to that, NC-TCP based application sets the target rate based on the feedback rate of the network. NC-TCP uses a rate-based congestion control mechanism to regulate the sending rate. It uses \textit{TCP-pacing} to regulate the sending rate. The sending rate is set to the feedback throughput. This is why NC-TCP does not send more data than network would be able to handle. As a result, although it results in a very small queuing delay, packets may wait in the TCP's sending buffer (congestion window) to be scheduled to sent out. This increases the RTT. This is why RTT produced by the NC-TCP is not exactly same as the propagation delay. Rather $RTT/RTT_{min}$ indicates how much encoder has overshot with respect to the network throughput. Here $RTT_{min}$ is the minimum RTT which is considered as the \textit{propagation delay}. We set the encoder target rate as 
\begin{displaymath}
R_t(t) = \frac{r_i(t)}{\frac{RTT}{RTT_{min}}}
\end{displaymath}
where $r_i(t)$ is the feedback throughput received from the network. Note that $\frac{RTT}{RTT_{min}} \geq 1$. This is why the target encoding rate is less than the feedback throughput. This is how NC-TCP based appliactions set the target encoding rate based on the network-feedback and past history of overshooting.


\chapter{Implementation}\label{chpt:implementation}
We have implemented NC-TCP and XCP in Linux kernel\footnote{https://github.com/tamimcse/Linux}. We also have found that TCP Inigo Linux kernel implementation in the Internet \footnote{https://github.com/systemslab/tcp\_inigo}. Our software architecture for the both NC-TCP and XCP includes two parts: NC-TCP host and NC-TCP router.

NC-TCP end point is implemented by adding a new option to Linux TCP stack. In contrast to the traditional TCP, NC-TCP uses \textit{TCP-pacing} \cite{aggarwal2000understanding} to regulate the sending rate. Here the sending rate is set to the feedback rate received from the network. The congestion window is also set $\frac{r_i(t) * RTT}{MSS}$ where $MSS$ represents the \textit{maximum segment size}. Linux TCP stack does not have a native \textit{TCP-pacing} implementation. TCP-pacing has been implemented using \textit{fq} (fair queue) Qdisc (queuing discipline). Qdisc is the traffic control mechanism in the Linux kernel. XCP on the other hand uses window based congestion control. XCP sender calculates the congestion window based on the feedback received from the XCP router.

NC-TCP router has been implemented in the Linux router as a new Qdisc kernel module. We have used Linux router by enabling the \textit{ip\_forward} option in Linux. The Qdisc kernel module inspects the NC-TCP option and sets a feedback rate based on the delay and fairness controller. XCP router is also implemented in the same manner where the rate in calculated based on the controller described in \cite{katabi2002internet}. 


\chapter{Experimental Setup}\label{chpt:experimentalsetup}
We have created a topology as Figure \ref{topology} using Mininet \cite{lantz2010network}. We have used \textit{NetEm} Qdisc to set the delay and \textit{htb} (hierarchical token bucket) Qqisc to set the throughputs on the network interfaces\footnote{http://lartc.org/}. We verified the throughput and latency of our setup using \textit{ping} and \textit{iperf}. We have run our experiment on a laptop running Ubuntu 16.04 with our modified Linux kernel 4.9.0. The laptop has a core i7 processor with four cores and 16GB memory.

We also developed a GStreamer\footnote{https://gstreamer.freedesktop.org/} based application\footnote{https://github.com/tamimcse/gst-streamer} in C to stream video from the sources. The source nodes act as a TCP server and the sink nodes act as a TCP client. Once the connection has been established, the server streams video to the client. In this experiment, we used a clip from Big Buck Bunny\footnote{http://bbb3d.renderfarming.net/download.html}.  The source application produces \textit{512X340} video at 30 fps.  This video is encoded into H.264 format. Here we used adaptive bitrate streaming where the bitrate of the video is adapted based on the network throughput. We used one-pass constant bitrate (CBR) encoder to produce the desired bitrate. Such one-pass encoder is traditionally used for real-time streaming. The GStreamer source updates the encoding rate in every 500 milliseconds. It uses \textit{getsockopt} system call to get feedback throughput from the TCP stack. It updates the encoding rate based on the feedback. On the receiving side, each node has a GStreamer sink application that plays the video as soon as a new NAL (network abstraction layer) unit is received.


\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{fig/topology}
	\caption{Topology}\label{topology}
\end{figure} 

\chapter{Evaluation}\label{chpt:evaluation}
This section compared the performance of NC-TCP with other delay based TCP. Loss-based TCP such as TCP CUBIC \cite{ha2008cubic} results in substantial delay in the router which is not acceptable for interactive traffic. Recently Google proposed congestion based congestion control, TCP BBR \cite{45646} which adjusts the sending rate by probing the network. But it also results in substantial queuing delay in our in our experimental test-bed which makes it unsuitable for interactive video streaming. We found TCP CDG \cite{hayes2011revisiting} and TCP Inigo \cite{shewmaker2016tcp} to cause very small queuing delay which make them suitable for interactive video streaming. Moreover we found that TCP Inigo outperforms TCP CDG in achieving higher throughput and lower latency. This is why, in this section we compared the performance of NC-TCP with that of TCP Inigo. This section also compared NC-TCP with XCP \cite{katabi2002internet}. XCP and RCP \cite{dukkipati2007rate} are explicit rate control mechanism which are promising alternative to TCP. RCP is designed to minimize the flow completion time but it results in higher queuing delay \cite{dukkipati2007rate}. This is why RCP is not suitable for interactive video streaming. XCP on the other hand results in very small queuing delay. This is why we also compared NC-TCP to that of XCP. This section compared the performance of one-way flows in order to avoid the reverse path affect. 


The primary evaluation criteria in this section are the queuing delay on the bottleneck router and the throughput fairness. As NC-TCP, XCP and TCP Inigo fully utilize the bottleneck link, higher fairness indicates that all the flows get higher throughput while lower fairness indicates that some flows get higher throughput while other flows are not receiving higher throughput from the bottleneck link.


\section{Single bottleneck link}\label{sect:evaluation_one}

We have conducted our experiment on the topology describe in Figure \ref{topology}. In the experiment, we have started three flows simultaneously and let it run for 80 seconds. We have run the experiment for NC-TCP, XCP and TCP Inigo separately. We have shown the throughput, queuing delay, round-trip time and Jain's fairness index in Figure \ref{im-cubuc}. We have modified the \textit{tcp\_probe} kernel module to record throughput and RTT on the sender. Here \textit{tcp\_probe} takes sample as soon as the congestion window changes. The network-controller we developed also records the queue backlog  using Linux \textit{proc} file system.  


The Figure \ref{im-cubuc} shows that both NC-TCP and XCP produces smooth throughput. Such smooth throughput of is very suitable for adaptive video streaming. On the other hand, the throughput of TCP Inigo fluctuates very rapidly compared to NC-TCP and XCP. 

The Figure \ref{im-cubuc} has also shown the queuing delay of the bottleneck router. The queuing delay has been calculated using $\frac{q(t)}{B} $ where $B$ is the bottleneck throughput. The figure shows that NC-TCP outperforms XCP and TCP Inigo in queuing delay. TCP Inigo regulates the sending rate based on the delay-gradient observed on the receiver. It has no real network information. It rather tries to estimate the extent of congestion based on the implicit information, the delay observed on the receiver. NC-TCP on the other hand regulates the sending rate based on the actual congestion information. This is why NC-TCP performs significantly better than TCP Inigo. The figure also shows that XCP produces spikes in queuing delay. This is because it uses standing queue in rate calculation. Standing queue is the minimum queue backlog during a control interval. XCP also uses window-based congestion control which causes bursty traffic in the bottleneck router. NC-TCP on the other hand uses instantaneous queue backlog in rate calculation. This is why it reacts sooner to congestion than XCP. NC-TCP also use \textit{TCP-pacing} to regulate the sending rate. This is why, it does not send bursty traffic to network. 

\begin{figure*}[!t]
	\vspace{-5\baselineskip}
	\begin{subfigure}[t]{\textwidth}
		\includegraphics[width=9cm]{fig/h1-throughput}
		\includegraphics[width=9cm]{fig/backlog}
	\end{subfigure}
	\begin{subfigure}[t]{\textwidth}
		\vspace{-3\baselineskip}
		\includegraphics[width=9cm]{fig/h1-rtt}
		\includegraphics[width=9cm]{fig/fairness}
	\end{subfigure}%
	\vspace{-1\baselineskip}	
	\caption{Comparison among NC-TCP, XCP and TCP Inigo in an interactive VDN}\label{im-cubuc}
\end{figure*}


\begin{figure*}[!t]
	\vspace{-3\baselineskip}
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=8.5cm]{fig/flows-inigo}
		\vspace{-3\baselineskip}
		\caption{Three TCP Inigo flows 15 seconds apart}\label{flows-cdg}
	\end{subfigure}%
	~ 
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{fig/flows-im}
		\vspace{-3\baselineskip}
		\caption{Three NC-TCP flows 15 seconds apart}\label{flows-im}
	\end{subfigure}%	 
	\caption{NC-TCP and TCP Inigo self-fairness comparison}\label{fairness}
\end{figure*}

The Figure \ref{im-cubuc} also compared the smoothed RTT (SRTT) experienced by the protocols. It shows that NC-TCP outperforms TCP Inigo and XCP in reducing SRTT. Note that, average RTT in our experimental test-bed is 140 milliseconds. The round-trip time produced by NC-TCP is also close to 140 milliseconds. It is also noteworthy that although queuing delay in NC-TCP is close to zero, the RTT is not equal to the propagation delay. This is because NC-TCP segments may wait in the sender buffer before being scheduled by the \textit{TCP-pacing} Qdisc.  


Finally the Figure \ref{im-cubuc} has compared the Jain's fairness index for the protocols. The Jain's fairness index has been calculated using the formula $\frac{{(\sum_{i=1}^{n} x_i)}^2}{n \sum_{i=1}^{n} {x_i}^2}$ where $x_i$ is the throughput of flow $i$ and $n$ is the total number of flows. Higher fairness index indicates that the protocol is better in fairness. The figure shows that both NC-TCP and XCP outperforms TCP Inigo in fairness. It is noteworthy that although XCP exhibits occasional downward spikes in fairness index, it performs very fairly most of the time. Both NC-TCP and XCP divides the bottleneck throughput equally among the flows. This results in very high fairness index. On the contrary, TCP Inigo results in very fluctuating queuing delay which cause the congestion window to fluctuate even more. As a result, TCP Inigo performs poorly in fairness compared to XCP and NC-TCP. Note that low fairness results in lower throughput to some flows which results in lower QoE for interactive video streaming. 


\begin{figure*}[!t]
	\vspace{-3\baselineskip}
	\begin{subfigure}[!t]{\textwidth}
		\includegraphics[width=9cm]{fig/rtt/backlog}
		\includegraphics[width=9cm]{fig/rtt/fairness}		
	\end{subfigure}
	\vspace{-2\baselineskip}	
	\caption{Evaluating RTT fairness for three flows with different RTTs in interactive VDN}\label{rtt-fairness}
\end{figure*}


\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{fig/parkinglot}
	\caption{Parking lot topology with multiple bottleneck links}\label{parkinglot}
\end{figure}


\section{Self-fairness}\label{sect:evaluation_two}
Here we have examined the self fairness of NC-TCP and TCP Inigo. We have run the experiment again where each flow is 15 seconds apart. Figure \ref{fairness} shows three flows competing for 1Mbps bottleneck link. Figure \ref{flows-cdg} shows that without the present of other flows, TCP Inigo can utilize the available throughput. But it performs poorly when it starts competing with other flows. It changes the congestion window rapidly based on the queuing delay caused by other flows. This is why throughput also fluctuates rapidly. Contrary to that, NC-TCP divides the available throughput fairly among the flows. This is why NC-TCP flows get fair throughput from the bottleneck link. Figure \ref{flows-im} shows that NC-TCP also able to utilize the available throughput in the absence of other flows. It also shows that when three NC-TCP shares a bottleneck link, they get nearly fair amount of throughput from the bottleneck link. The throughput also does not fluctuates as much as TCP Inigo which results in better QoE for adaptive video streaming. 


\section{RTT-fairness}\label{sect:evaluation_three}
The throughput allocation of NC-TCP does not depend on the RTTs of the flows. To evaluate the RTT-fairness of NC-TCP, we have modified the topology in Figure \ref{topology} such that the three different flows have different RTTs:  80ms, 100ms and 120ms. Figure \ref{rtt-fairness} shows the queuing delay and fairness index for the topology. It shows that NC-TCP is fair to flows with different RTTs. NC-TCP is also able to contain the queuing delay in the presence of different RTT flows  (as Figure \ref{rtt-fairness}). This is why even though the feedback-delays are different for each flow, they receive smooth feedback throughput. On the other hand, XCP and TCP Inigo exhibit spikes in queuing delay. This is why they also exhibit variability in fairness index. 


\section{Multiple bottleneck links}\label{sect:evaluation_four}
Figure \ref{parkinglot} shows a topology with multiple bottleneck links and the flows. Here the links connecting two routers are the bottleneck links. The links connecting a router and a host are the access links. The throughput of bottleneck and access links are 660kbps and 1024kbps respectively. The propagation delays of the links are shown in the figure. We also have introduced 2ms and 3ms delay variance on the access links and bottleneck links respectively. We conducted the same experiment as before on this topology. Here four flows are started simultaneously on the source nodes. We let the experiment run for 80 seconds. Figure \ref{parkinglotres} compared performance of NC-TCP to that of TCP Inigo and XCP. The figures shows that both NC-TCP and XCP is very effective in containing queuing delay whereas Inigo results in very high queuing delay in the presence of multiple bottlenecks. NC-TCP also outperforms XCP and Inigo in fairness index. 

\begin{figure*}[!t]
	\begin{subfigure}[!t]{\textwidth}
		\includegraphics[width=9cm]{fig/parkinglot/backlog}
		\includegraphics[width=9cm]{fig/parkinglot/fairness}		
	\end{subfigure}	
	\caption{Comparison among NC-TCP, XCP and TCP Inigo in an interactive VDN with multiple bottleneck links}\label{parkinglotres}
\end{figure*}



\section{Differential fairness}\label{sect:evaluation_five}
Interactive VDN needs to support heterogeneous endpoints such as smart phones, laptops, TV and VR headset at the same time. The videos used in different endpoints often differ in encodings, resolutions and frame rates. This is why different endpoints may need different throughputs. Network-centric congestion control has a major advantage in this regard. As a router is aware of the throughput requirement of each flow passing through it, it can apply differential fairness in throughput allocation. NC-TCP option (Figure \ref{im-option}) has \textit{expected throughput} field which would be used by the senders to specify their throughput requirements. Bottleneck router can apply weighted fairness based on the \textit{expected throughput} in allocating throughput to each flow.

\section{Visual Interruption}\label{sect:evaluation_six}
Visual interruption is the situation where video player on a receiver enters into a buffering mode. Such interruption degrades the QoE significantly. Table \ref{visual} shows the number of visual interruptions experienced for different topologies. It shows that both NC-TCP and XCP performs significantly well compared to TCP Inigo. 

\begin {table}[H]
\caption {Number of visual interruptions} \label{visual} 
\begin{center}
	\begin{tabular}{ | m{5em} | m{3cm}| m{5cm} | } 
		\hline
		& Single bottleneck & Multiple bottleneck\\ 
		\hline
		TCP Inigo & 2 & 20 \\ 
		\hline
		XCP & 0 & 0 \\ 
		\hline
		NC-TCP & 0 & 0 \\		
		\hline
	\end{tabular}
\end{center}
\end {table}

\chapter{Research plan, Experimental plan and Expected results}\label{chpt:research}
We have already discussed NC-TCP. But in order for NC-TCP to be used in the real network, line-rate NC-TCP router has to be developed. Recent advances in software defined networks (SDN) enables us to implement new protocol which was not possible before. This chapter describes the research plan of developing line-rate NC-TCP router using SDN.

\section{Software Define Networks}\label{sect:research_one}

Initial focus of SDN was to use CPU for packet processing. CPUs are highly programmable. Such CPU based router uses DPDK (Data Plane Development Kit) for packet processing and forwarding. DPDK is a technology that bypasses the kernel and enables to process packet in application layer. DPDK application can be programed using BPF (Berkley Packet Filter) framework. BPF program can be written in C or P4. Although software router provides 40Gbps throughput, it is very small compared to hardware switch which provides several terabits per second. 

\subsection{Is Software Forwarding Scalable?}\label{sect:research_one_one}
This section analyses why CPU based software router is cannot forward packets at line-rate. Let us assume that each NIC of a switch is 100Gb. 100Gb NIC can receive $8.4$ Million packets per second where each packet is 1500byte. This is why a switch will have $119ns$ to process each packet. This is why a 2GHz Xeon core CPU can spend only $238$ cpu cycles to process and forward the packet. But packet forwarding is a IO intensive operation, not CPU intensive. For instance, for IPv4 forwarding requires at least two memory access. Each memory access 120-140 cpu cycles. This is why IPV4 forwarding requires more than $238$ cpu cycle. This problem is exacerbated for smaller packers or faster NICs. 

\subsection{Software Packet processing}\label{sect:research_one_two}
Hardware switch data-plane can forward packets at several terabits per seconds. Such switch data-plane is quite common in modern switches. In new approach in SDN, packet forwarding is done in hardware and packet processing is done in a CPU in the NIC. In this model, each NIC in the switch has a CPU. The programmable NICs are generally connected by a fixed function switch fabric in a box. Figure \ref{sdn} shows a SmartNIC Box where packets are forwarded by a fixed function switch among the NICs. In this architecture, actual packet forwarding is done by the fixed function switch. Programmable NIC are responsible for different packet processing.  In this research, the NIC is responsible for processing TCP option to implement NC-TCP. Programmer uses data-plane programming to program the CPUs in the NIC. 

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{fig/sdn}
	\caption{SmartNIC Box: Programmable NICs connected  by a fixed function switch}\label{sdn}
\end{figure}

\subsection{Line-rate Packet Processing}\label{sect:research_one_three}
It has shown that a programmable switch can forward packets at line-rate if each port can process packets at line-rate \cite{argyraki2008can}. Most of the switches come with 10Gb/s and 40Gb/s port. This is why NC-TCP software needs to process packets at 40Gb/s.

\subsection{Data-plane Programming}\label{sect:research_one_four}
The programming environment depends on switch manufacturer. Switch manufacturer provides a proprietary SDK that provides very limited programming capability to others. Programmable switch architectures such as RMT \cite{bosshart2013forwarding}, Intel FlexPipe \cite{flexpipe} and Cavium  XPliant switch \cite{xplaint} uses their proprietary SDK to program the switch data-plane. 

Recently P4 \cite{bosshart2014p4} language has been proposed to program the switch data plane. However, P4 does not yet provide the primitives necessary to support many resource management schemes. Recently eBPF (extended Binary packet Filter) programming framework have been developed that provides a standardized way to program the data-plane. NC-TCP data-plane needs to modify packets based on queue length and number of flows. eBPF framework makes the queue length and number of flows accessible through meta-data. This is why we are planning to use eBPF to program NC-TCP router. An eBPF program can be offloaded to a NIC. The CPU attached to each NIC will execute the eBPF program. The eBPF program will be executed on each packet. It will inspect the NC-TCP option and assign the feedback throughput based the queue length and number of flows.


\subsection{Open Source SDN}\label{sect:research_one_five}
The switch manufactures provides a proprietary SDK to utilize the switch. But closed source nature of SDK refrains appliance vendor and individual developers to program the switch. The switch vendor includes Intel, Mellanox, Brodcom, Cavium, Barefoot, Marvell. Recently people from Mellanox and Intel came forward to solve this problem. A switch driver model \textit{switchdev} has been proposed to replace the proprietary SDK. Mellanox have few hardware switches based on switchdev. However currently they do not support eBPF program. Mellanox however expressed interest to support eBPF offloading in the future. This is why we are planning to develop eBPF program with Linux router. Once the hardware-router adds eBPF offloading, the same program can be offloaded to the hardware-router.

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{fig/switchdev}
	\caption{Inside Linux router}\label{switchdev}
\end{figure}


\subsection{Linux Router}\label{sect:research_one_six}
Figure \ref{switchdev} shows different components of a Linux Router. Here kernel and user-space represents the control plane. The switch hardware represents the data-plane. Route kernel module is responsible for routing. FIB (Forwarding Information Base) represents the routing table. This is a routing table in the control-plane. Switch also maintains a copy of the same routing table in the hardware. That is the routing table in the data-plane. Route kernel module can offload the routing table from software to hardware via switch driver. Switch driver loads the routes to hardware from Route via memory mapped IO (MMIO).

Figure \ref{switchdev} also shows a Bridge kernel module. Bridge is responsible for switching based MAC address. FDB (Forwarding Database) represents L2 forwarding table. Like Route, the FDB can be offloaded to switch hardware via switch driver. 

Finally iproute2 is a user-space utility that is responsible for adding and removing entries to routing and forwarding table. iproute2 is also responsible for offloading eBPF program to switch hardware. Switch driver loads the eBPF program on to the switch hardware via memory-mapped IO.

Currently Mellanox has two switches that can offload routing and forwarding table from kernel to the hardware. But currently there is no switch available that can offload eBPF program. This is why we are developing eBPF program in Linux router with virtual data-path. Figure \ref{veth} shows a Linux router without hardware data-path. Hardware data-plane is replaced by veth (virtual ethernet). Veth appears to kernel as a physical NIC. Packet forwarding is done by Router and Bridge kernel module. \textit{iproute2} loads the eBPF program on to veth. The eBPF program is executed on each incoming and outgoing packets of veth. 

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{fig/veth}
	\caption{Linux router without switch hardware}\label{veth}
\end{figure}


\section{Experimental Plan}\label{sect:research_two}
We are going implement the eBPF program in Linux router. We can attach an eBPF program to a NIC in Linux router. That eBPF program will be executed on each packets that go through the NIC. 

We will create a topology as Figure \ref{linerate}. The objective of this experiment to see how much throughput the NC-TCP router can achieve. Here we will use \textit{iperf} to generate packet and to measure throughput. We will use 1500KB packet in this case. 

We will also examine eBPF instruction-set. BPF compiler enables us to examine the instruction-set that the eBPF program produces. The instruction set allows us to calculate how many CPU cycle will be needed for the NC-TCP eBPF program. This allows us to determine how fast the CPU should be in order to process the packets in line-rate.  

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{fig/linerate}
	\caption{Experimental setup for eBPF NC-TCP program}\label{linerate}
\end{figure}


\section{Research Plan}\label{sect:research_three}
The Table~\ref{table:example} shows the schedule to finish the
planed work and tentative month of dissertation defense.

\begin{table}[htbp]
	\begin{center}
		\begin{tabular}{|l|p{0.5\linewidth}|}
			\hline
			\textbf{Date} & \textbf{Task}\\ \hline September 1  – December 31, 2017 & 
			 Develop eBPF data-plane for Linux router.\\ \hline        
			January 1 – May 30, 2018 & Develop experimental setup. Conduct the  experiments and capture experimental results. Conduct eBPF instruction-set analysis. Write papers and submit for publication\\ \hline   			 
			June 1 – July 30 , 2018 & Write dissertation\\ \hline
			August 1 – August 30, 2018 & Defend dissertation\\ \hline
		\end{tabular}
		\caption{\label{table:example}Plan to finish proposed study with approximate dates.}
	\end{center}
\end{table}	



\section{Expected Results}\label{sect:research_four}
In this research we have simulated the data plane on in Mininet. We have implemented a NC-TCP router as a Qdisc kernel module. We have created a topology as Figure \ref{linerate}. Our Mininet simulation shows that our NC-TCP qdisc implementation can process packets at 50Gb/s rate with just one Intel i7 2GHz processor core. The core also has been 80\% utilized during our experimentation. This however suggests that the line-rate NC-TCP packet processing on programmable NIC is achievable.

Once NC-TCP router has been developed in eBPF, we expect to determine what CPU clock-rate is necessary for line-rate packet processing by analyzing eBPF instruction-set. We also expect to that eBPF program will be able to process packets at 40Gb/s in Linux router.



\bibliographystyle{IEEEtran}
\bibliography{dissertation} 

\end{document}